package com.miya.mpos.views;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.text.TextUtils;
import android.view.View;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.alibaba.android.arouter.launcher.ARouter;
import com.miya.iot.sco.beans.SelfCashierTerminalConfig;
import com.miya.iot.sco.beans.viewbeans.ViewLocalPreparePaymentInfo;
import com.miya.iot.sco.beans.viewbeans.ViewPaySuccessInfo;
import com.miya.iot.sco.constance.ARouterPathConstant;
import com.miya.iot.sco.constance.MiYaPayPlantformPayWayEnum;
import com.miya.iot.sco.core.utils.StringPriceFormat;
import com.miya.iot.sco.widget.CenterToasty;
import com.miya.iot.sco.impl.base.ScoPayResultActionViewActivity;
import com.miya.mpos.R;
import com.miya.mpos.R2;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * Created by pupu on 2019-07-01
 * 佛祖开光，永无bug
 * God bless U
 */
@Route(path = ARouterPathConstant.MPOS_PAY_RESULT_ACTIVITY)
public class MposPayResultActivity extends ScoPayResultActionViewActivity {

    ViewLocalPreparePaymentInfo viewLocalPreparePaymentInfo;

    ViewPaySuccessInfo viewPaySuccessInfo;

    boolean isUploadSuccess;

    String payType;

    SelfCashierTerminalConfig selfCashierTerminalConfig;
    @BindView(R2.id.tvPayPrice)
    TextView tvPayPrice;
    @BindView(R2.id.tvStatus)
    TextView tvStatus;
    @BindView(R2.id.tvOrderStatus)
    TextView tvOrderStatus;
    @BindView(R2.id.tvRePrint)
    TextView tvRePrint;
    @BindView(R2.id.tvOrderNo)
    TextView tvOrderNo;
    @BindView(R2.id.tvPayWay)
    TextView tvPayWay;
    @BindView(R2.id.tvTradeNo)
    TextView tvTradeNo;
    @BindView(R2.id.tvTradeTime)
    TextView tvTradeTime;
    @BindView(R2.id.tvGoHome)
    TextView tvGoHome;
    @BindView(R2.id.tvPayResultTitle)
    TextView tvPayResultTitle;
    @BindView(R2.id.tvAccountInfo)
    TextView tvAccountInfo;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setFullScreen();
        setContentView(R.layout.activity_new_mpos_pay_result);
        ButterKnife.bind(this);
        initView();
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        setFullScreen();
    }

    private void initView() {
        if (getIntent() == null || getIntent().getExtras() == null) {
            CenterToasty.error(this.getApplicationContext(), "数据错误").show();
            finish();
        }
        if (accountInfoComponent != null) {
            selfCashierTerminalConfig = accountInfoComponent.getSelfCashierTerminalConfig();
            if(selfCashierTerminalConfig.getScoFunctionConfig().isStaffLoginFeatureEnable()){
                String staffName = selfCashierTerminalConfig.getShopConfig().getStaffName();
                String storeName = selfCashierTerminalConfig.getShopConfig().getStoreName();
                tvAccountInfo.setText(getString(R.string.store_and_staff_info,
                        TextUtils.isEmpty(storeName)?"--":storeName,TextUtils.isEmpty(staffName)?"--":staffName ));
                tvAccountInfo.setVisibility(View.VISIBLE);
            }else{
                tvAccountInfo.setVisibility(View.GONE);
            }
        }

        viewPaySuccessInfo = (ViewPaySuccessInfo) getIntent().getExtras().getSerializable("viewPaySuccessInfo");
        isUploadSuccess = getIntent().getExtras().getBoolean("isUploadSuccess");
        payType = getIntent().getExtras().getString("payType");
        viewLocalPreparePaymentInfo = (ViewLocalPreparePaymentInfo) getIntent().getExtras().getSerializable("viewLocalPreparePaymentInfo");

        //set pay state
        tvPayResultTitle.setText(R.string.gathering_succeed);
        tvPayPrice.setText("￥" + StringPriceFormat.transStringPriceToDecimalString(viewLocalPreparePaymentInfo.getPayServiceResponse().getTradPrice()));

        //set pay info
        tvOrderNo.setText(viewPaySuccessInfo.getPayServiceResponse().getShopTradeNo());
        tvPayWay.setText(MiYaPayPlantformPayWayEnum.MiyaPayType.find(viewPaySuccessInfo.getPayServiceResponse().getChanelTag()).getDesc());
        tvTradeNo.setText(viewPaySuccessInfo.getPayServiceResponse().getChanelSerialNumber());
        tvTradeTime.setText(viewPaySuccessInfo.getPayServiceResponse().getMiyaResponseTime());

        if (!isUploadSuccess) {
            tvOrderStatus.setText(R.string.order_upload_failed);
        }

        //打印小票
        tvStatus.setText(R.string.str_on_print);
        //go 2 print
        printOrderInfo(viewLocalPreparePaymentInfo, viewPaySuccessInfo);
    }

    @Override
    protected void onPrintFailed(String errorMsg) {
        super.onPrintFailed(errorMsg);
        hideWaitingDialog();
        tvRePrint.setVisibility(View.VISIBLE);
        tvStatus.setText(R.string.str_print_failed);
        tvGoHome.setEnabled(true);
        CenterToasty.error(this, errorMsg).show();
    }

    @Override
    protected void onPrintSuccess() {
        super.onPrintSuccess();
        tvRePrint.setVisibility(View.GONE);
        tvGoHome.setEnabled(true);
        tvStatus.setText(R.string.str_print_success);
    }

    @OnClick(R2.id.tvRePrint)
    public void onRePrintClicked(View view) {
        printOrderInfo(viewLocalPreparePaymentInfo, viewPaySuccessInfo);
    }

    @OnClick(R2.id.tvGoHome)
    public void onGoHomeClicked(View view) {
        finishOrderWithSuccessfulPay();
        clearDataSource();
        start2Home();
    }

    void start2Home() {
        try {
            ARouter.getInstance().build(selfCashierTerminalConfig.getScoRuntimeConfig().getScoHomeActionViewActivityRouterPath()).navigation(this);
            return;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        ARouter.getInstance().build(ARouterPathConstant.MPOS_HOME_ACTIVITY).navigation(this);
    }
}
