package com.miya.mpos.views.legao;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.constraint.ConstraintLayout;
import android.text.TextUtils;
import android.widget.ImageView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.alibaba.android.arouter.launcher.ARouter;
import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;
import com.jakewharton.rxbinding.view.RxView;
import com.miya.iot.sco.beans.local.LocalLoginAccountInfo;
import com.miya.iot.sco.constance.ARouterPathConstant;
import com.miya.iot.sco.core.sharedpreferences.PreferencesEngine;
import com.miya.iot.sco.core.utils.AccountConfigHelper;
import com.miya.iot.sco.core.utils.AppInfoUtils;
import com.miya.iot.sco.impl.base.ScoHomeActionViewActivity;
import com.miya.iot.sco.impl.component.AccountInfoComponent;
import com.miya.mpos.R;
import com.miya.mpos.R2;

import java.util.concurrent.TimeUnit;

import butterknife.BindView;
import butterknife.ButterKnife;
import rx.functions.Action1;

import static com.miya.iot.sco.core.component.ScoCoreComponentName.SCO_COMPONENT_ACCOUNT;


@Route(path = ARouterPathConstant.LEGAO_MPOS_HOME_ACTIVITY)
public class MposLeGaoHomeActivity extends ScoHomeActionViewActivity {

    @BindView(R2.id.tvGoShopping)
    TextView tvGoShopping;
    @BindView(R2.id.vsWaiting)
    ConstraintLayout vsWaiting;
    @BindView(R2.id.tvAccountInfo)
    TextView tvAccountInfo;
    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setFullScreen();
        setContentView(R.layout.activity_mpos_home);
        ButterKnife.bind(this);
        initView();
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        setFullScreen();
    }

    private void initView() {
        RxView.clicks(tvGoShopping)
                .throttleFirst(1500, TimeUnit.MILLISECONDS)
                .subscribe(new Action1<Void>() {
                    @Override
                    public void call(Void aVoid) {
                        go2ScanGoods();
                    }
                });

        ImageView ivMerchantLogo = findViewById(R.id.ivMerchantLogo);
        if (ivMerchantLogo!=null){
            if (!TextUtils.isEmpty(AccountConfigHelper.getMerchatLogo(selfCashierTerminalConfig))) {
                String merchantLogo = AccountConfigHelper.getMerchatLogo(selfCashierTerminalConfig);
                Glide.with(this).load(merchantLogo)
                        .fitCenter()
                        .diskCacheStrategy(DiskCacheStrategy.ALL)
                        .into(ivMerchantLogo);
            }
        }

        if(!selfCashierTerminalConfig.getScoFunctionConfig().isStaffLoginFeatureEnable()){
            String userName = "";
            LocalLoginAccountInfo localLoginAccountInfo = PreferencesEngine.getInstance().getLoginAccountInfo();
            if (localLoginAccountInfo != null) {
                userName = localLoginAccountInfo.getUserName();
            }
            tvAccountInfo.setText(userName + "  " + AppInfoUtils.getVersionCode());
        }
        tvAccountInfo.setOnLongClickListener(v -> {
            ARouter.getInstance().build(ARouterPathConstant.MPOS_FUNC_CENTER_ACTIVITY)
                    .navigation(MposLeGaoHomeActivity.this);
            return false;
        });
    }

    void go2ScanGoods() {
        try {
            ARouter.getInstance().build(selfCashierTerminalConfig.getScoRuntimeConfig().getScoScanGoodsActionViewActivityRouterPath()).navigation(MposLeGaoHomeActivity.this);
            return;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        ARouter.getInstance().build(ARouterPathConstant.MPOS_SCAN_ACTIVITY).navigation(MposLeGaoHomeActivity.this);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if(selfCashierTerminalConfig.getScoFunctionConfig().isStaffLoginFeatureEnable()){
            AccountInfoComponent accountInfoComponent = (AccountInfoComponent) scoComponentProvider.getComponentByName(SCO_COMPONENT_ACCOUNT);
            String staffName =  accountInfoComponent.getSelfCashierTerminalConfig().getShopConfig().getStaffName();
            String storeName =  accountInfoComponent.getSelfCashierTerminalConfig().getShopConfig().getStoreName();
            tvAccountInfo.setText(getString(R.string.store_and_staff_info,
                    TextUtils.isEmpty(storeName)?"--":storeName,TextUtils.isEmpty(staffName)?"--":staffName ));
        }
    }
}
