package com.miya.mpos.views.legao;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.alibaba.android.arouter.launcher.ARouter;
import com.bumptech.glide.Glide;
import com.jakewharton.rxbinding.view.RxView;
import com.miya.iot.sco.beans.SelfCashierTerminalConfig;
import com.miya.iot.sco.beans.viewbeans.ViewBalanceInfo;
import com.miya.iot.sco.beans.viewbeans.ViewCouponInfo;
import com.miya.iot.sco.beans.viewbeans.ViewGoodsInfo;
import com.miya.iot.sco.beans.viewbeans.ViewMemberInfo;
import com.miya.iot.sco.beans.viewbeans.ViewOptionalDiscountInfo;
import com.miya.iot.sco.beans.viewbeans.ViewOrderInfo;
import com.miya.iot.sco.beans.viewbeans.ViewScanGoodsPageInfo;
import com.miya.iot.sco.constance.ARouterPathConstant;
import com.miya.iot.sco.core.actiondispatcher.ViewActions;
import com.miya.iot.sco.core.broadcast.StandardBroadcastInstance;
import com.miya.iot.sco.core.utils.AccountConfigHelper;
import com.miya.iot.sco.core.utils.ListUtils;
import com.miya.iot.sco.core.utils.PhoneUtils;
import com.miya.iot.sco.core.utils.ScanGunKeyEventHelper;
import com.miya.iot.sco.core.utils.StringPriceFormat;
import com.miya.iot.sco.core_old.base.BaseRecyclerViewAdapter;
import com.miya.iot.sco.impl.base.ScoScanGoodsActionViewActivity;
import com.miya.iot.sco.net.ErrorPowerEnum;
import com.miya.iot.sco.widget.CenterToasty;
import com.miya.mpos.R;
import com.miya.mpos.R2;
import com.miya.mpos.adapter.ScanGoodsAdapter;
import com.miya.mpos.widget.dialog.CancelOrderDialog;
import com.miya.mpos.widget.dialog.DeleteGoodConfirmDialog;
import com.miya.mpos.widget.dialog.ManualInputDialog;
import com.miya.mpos.widget.dialog.MposDiscountDialog;
import com.miya.mpos.widget.dialog.MposInputPriceDialog;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import rx.functions.Action1;

import static com.miya.iot.sco.core.broadcast.BroadcastActionConstance.BROADCAST_CANCEL_ORDER;
import static com.miya.iot.sco.core.broadcast.BroadcastActionConstance.BROADCAST_DELETE_GOODS;
import static com.miya.iot.sco.core.broadcast.BroadcastActionConstance.BROADCAST_MANUAL_DECREASE;
import static com.miya.iot.sco.core.broadcast.BroadcastActionConstance.BROADCAST_MANUAL_INCREASE;

/**
 * Created by pupu on 2019-06-25
 * 佛祖开光，永无bug
 * God bless U
 */
@Route(path = ARouterPathConstant.LEGAO_MPOS_SCAN_ACTIVITY)
public class MposLeGaoScanGoodsActivity extends ScoScanGoodsActionViewActivity {

    @BindView(R2.id.ivShopLogo)
    ImageView ivShopLogo;

    @BindView(R2.id.rcGoodsList)
    RecyclerView rcGoodsList;

    @BindView(R2.id.tvGoToPay)
    TextView tvGoToPay;

    @BindView(R2.id.llScanGoods)
    View llScanGoods;

    @BindView(R2.id.tvTotalDisc)
    TextView tvTotalDisc;

    @BindView(R2.id.tvPayPrice)
    TextView tvPayPrice;

    @BindView(R2.id.layoutMemberContainer)
    View layoutMemberContainer;

    @BindView(R2.id.tvMemberName)
    TextView tvMemberName;

    @BindView(R2.id.tvMemberPoint)
    TextView tvMemberPoint;

    @BindView(R2.id.tvAccountInfo)
    TextView tvAccountInfo;

    SelfCashierTerminalConfig selfCashierTerminalConfig;

    /**
     * shop car goods recyclerview adapter
     */
    private LeGaoGoodsAdapter scanGoodsAdapter;

    /**
     * 取消交易确认弹框
     */
    CancelOrderDialog cancelOrderDialog;

    ScanGunKeyEventHelper scanGunKeyEventHelper;

    ManualInputDialog manualInputDialog;

    ViewScanGoodsPageInfo viewScanGoodsPageInfo;

    ViewMemberInfo viewMemberInfo;

    MposInputPriceDialog inputPriceDialog;

    MposDiscountDialog discountDialog;

    DeleteGoodConfirmDialog deleteGoodConfirmDialog;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setFullScreen();
        setContentView(R.layout.activity_mpos_legao_scan_goods);
        ButterKnife.bind(this);
        initConfig();
        initView();
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        setFullScreen();
    }

    void initConfig() {
        if (accountInfoComponent != null) {
            selfCashierTerminalConfig = accountInfoComponent.getSelfCashierTerminalConfig();
        }
    }

    private void initView() {
        //set logo
        if (selfCashierTerminalConfig != null && selfCashierTerminalConfig.getLogoAndVideoConfig() != null) {

            if (selfCashierTerminalConfig.getScoFunctionConfig().isStaffLoginFeatureEnable()) {
                String staffName = selfCashierTerminalConfig.getShopConfig().getStaffName();
                String storeName = selfCashierTerminalConfig.getShopConfig().getStoreName();
                tvAccountInfo.setText(getString(R.string.store_and_staff_info,
                        TextUtils.isEmpty(storeName) ? "--" : storeName, TextUtils.isEmpty(staffName) ? "--" : staffName));
                tvAccountInfo.setVisibility(View.VISIBLE);
            } else {
                tvAccountInfo.setVisibility(View.GONE);
            }
        }

        //init recyclerview
        initGoodsRecyclerView();

        //init dialog
        discountDialog = new MposDiscountDialog(this);
        cancelOrderDialog = new CancelOrderDialog(this);
        manualInputDialog = new ManualInputDialog(this);
        manualInputDialog.setNumberInputFinishListener(new ManualInputDialog.NumberInputFinishListener() {
            @Override
            public void onInputFinishButtonClick(String s) {
                verifyCode(s, false);
            }
        });

        deleteGoodConfirmDialog = new DeleteGoodConfirmDialog(this);
        deleteGoodConfirmDialog.setOnDeleteListener(new DeleteGoodConfirmDialog.OnDeleteListener() {
            @Override
            public void onDelete(ViewGoodsInfo viewGoodsInfo) {
                if (viewGoodsInfo != null) {
                    decreaseGoodsNumber(scanGoodsAdapter.getDataSource(), viewGoodsInfo.getProductId(), true);
                }
            }
        });

        //init scan gun
        scanGunKeyEventHelper = new ScanGunKeyEventHelper();
        scanGunKeyEventHelper.setOnBarCodeCatchListener(new ScanGunKeyEventHelper.OnScanSuccessListener() {
            @Override
            public void onScanSuccess(String barcode) {
                verifyCode(barcode, true);
            }
        });

        tvGoToPay.setEnabled(false);
        tvGoToPay.setText(getString(R.string.balance_order_with_good_num, 0));
        //init click go 2 pay event
        RxView.clicks(tvGoToPay)
                .throttleFirst(1500, TimeUnit.MILLISECONDS)
                .subscribe(new Action1<Void>() {
                    @Override
                    public void call(Void aVoid) {

                        if (viewScanGoodsPageInfo == null
                                || ListUtils.isEmpty(viewScanGoodsPageInfo.getGoodsInfoList())
                                || scanGoodsAdapter.getDataSource() == null
                                || scanGoodsAdapter.getDataSource().size() == 0) {
                            return;
                        }

                        if (selfCashierTerminalConfig.getScoFunctionConfig().isNeedBalanceOrder()) {
                            if (viewMemberInfo != null) {
                                balanceOrder(viewScanGoodsPageInfo, viewMemberInfo);
                            } else {
                                balanceOrder(viewScanGoodsPageInfo);
                            }
                        } else {//如果不需要结算
                            //跳转结算页面
                            go2BalanceActivity(viewScanGoodsPageInfo, viewMemberInfo);
                        }
                    }
                });

        RxView.clicks(tvTotalDisc)
                .throttleFirst(1500, TimeUnit.MILLISECONDS)
                .subscribe(aVoid -> {
                    if (!discountDialog.isShowing() && viewScanGoodsPageInfo != null) {
                        ViewOrderInfo viewOrderInfo = viewScanGoodsPageInfo.getOrderInfo();
                        List<ViewCouponInfo> viewCouponInfos = viewScanGoodsPageInfo.getCouponInfo();
                        if (!ListUtils.isEmpty(viewCouponInfos) && viewOrderInfo != null) {
                            discountDialog.bindData(viewCouponInfos, viewOrderInfo.getCouponPrice());
                            discountDialog.show();
                        }
                    }
                });
    }

    @Override
    protected void onVerifyMemberInfoFail(String errorMsg) {
        super.onVerifyMemberInfoFail(errorMsg);
        hideWaitingDialog();
        if (manualInputDialog != null) {
            manualInputDialog.showCantRecognizeGoodsHint();
        }
        CenterToasty.error(this, errorMsg).show();
        refreshSubmitBtnStatus();
    }

    @Override
    protected void onVerifyMemberInfoSuccess(ViewMemberInfo viewMemberInfo) {
        super.onVerifyMemberInfoSuccess(viewMemberInfo);
        if (manualInputDialog != null) {
            manualInputDialog.dismiss();
        }
        hideWaitingDialog();
        setMemberView(viewMemberInfo);
        tvGoToPay.setEnabled(true);

        //输入会员立即变价
        // 购物车信息不为空   结算一次
        if (!ListUtils.isEmpty(scanGoodsAdapter.getDataSource())) {
            getGoodsInfoByBarcodeContinuous("");
        }
    }

    private void setMemberView(ViewMemberInfo viewMemberInfo) {
        if (viewMemberInfo == null) {
            return;
        }
        this.viewMemberInfo = viewMemberInfo;
        layoutMemberContainer.setVisibility(View.VISIBLE);
        tvMemberName.setText(viewMemberInfo.getMemberName());
        if (!TextUtils.isEmpty(viewMemberInfo.getMemberPoint())) {
            tvMemberPoint.setVisibility(View.VISIBLE);
        } else {
            tvMemberPoint.setVisibility(View.GONE);
        }
    }

    @Override
    protected void onBalanceOrderFailed(String errorMsg) {
        super.onBalanceOrderFailed(errorMsg);
        hideWaitingDialog();
        CenterToasty.error(this, errorMsg).show();
        refreshSubmitBtnStatus();
    }

    @Override
    protected void onBalanceOrderSuccess(ViewBalanceInfo viewbalanceInfo) {
        super.onBalanceOrderSuccess(viewbalanceInfo);
        hideWaitingDialog();
        if (TextUtils.isEmpty(viewbalanceInfo.getPayPrice())) {
            CenterToasty.error(this, "结算信息错误！(实付金额为空)").show();
            return;
        }
        if (TextUtils.isEmpty(viewbalanceInfo.getOrderPrice())) {
            CenterToasty.error(this, "结算信息错误！(订单金额为空)").show();
            return;
        }
        //结算成功，弹出结算订单信息对话框(现已和支付方式选择框二合一)
        viewScanGoodsPageInfo.getOrderInfo().setPayPrice(viewbalanceInfo.getPayPrice());
        viewScanGoodsPageInfo.getOrderInfo().setConponInfoList(viewbalanceInfo.getCouponInfos());
        viewScanGoodsPageInfo.getOrderInfo().setCouponPrice(viewbalanceInfo.getCouponPrice());
        viewScanGoodsPageInfo.getOrderInfo().setOrderPrice(viewbalanceInfo.getOrderPrice());
        //更新结算户的商品信息，但是界面展示不更新
        if (viewbalanceInfo.getGoodsInfoList() != null && viewbalanceInfo.getGoodsInfoList().size() > 0) {
            viewScanGoodsPageInfo.setGoodsInfoList(viewbalanceInfo.getGoodsInfoList());
        }
        //跳转结算页面
        go2BalanceActivity(viewScanGoodsPageInfo, viewMemberInfo);
    }

    private void go2BalanceActivity(ViewScanGoodsPageInfo viewScanGoodsPageInfo, ViewMemberInfo viewMemberInfo) {
        Bundle bundle = new Bundle();
        bundle.putSerializable("viewScanGoodsPageInfo", viewScanGoodsPageInfo);
        bundle.putSerializable("viewMemberInfo", viewMemberInfo);
        try {
            ARouter.getInstance().build(selfCashierTerminalConfig.getScoRuntimeConfig().getScoBalanceOrderActionViewActivityRouterPath()).with(bundle).navigation(this);
            return;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        ARouter.getInstance().build(ARouterPathConstant.MPOS_BALANCE_ORDER_ACTIVITY).with(bundle).navigation(this);
    }

    @Override
    protected void onQueryGoodsInfoSuccess(ViewScanGoodsPageInfo scanGoodsPageInfo) {
        super.onQueryGoodsInfoSuccess(scanGoodsPageInfo);
        //dismiss dialog
        hideWaitingDialog();
        if (manualInputDialog != null) {
            manualInputDialog.dismiss();
        }
        if (inputPriceDialog != null) {
            inputPriceDialog.dismiss();
        }
        if (scanGoodsPageInfo == null || scanGoodsPageInfo.getGoodsInfoList() == null || scanGoodsPageInfo.getOrderInfo() == null || scanGoodsPageInfo.getGoodsInfoList().size() == 0) {
            setEmptyGoodsState();
            return;
        }

        this.viewScanGoodsPageInfo = scanGoodsPageInfo;

        if (llScanGoods.getVisibility() == View.VISIBLE) {
            llScanGoods.setVisibility(View.GONE);
        }

        //refresh goods list
        //增加 新的商品
        if (rcGoodsList.getAdapter() instanceof BaseRecyclerViewAdapter) {
            int previousSize = scanGoodsAdapter.getDataSource().size();
            if (previousSize < scanGoodsPageInfo.getGoodsInfoList().size()) {
                scanGoodsAdapter.getDataSource().clear();
                scanGoodsAdapter.add(scanGoodsPageInfo.getGoodsInfoList(), 0);
                rcGoodsList.scrollToPosition(0);
                scanGoodsAdapter.notifyItemInserted(0);
            } else {
                scanGoodsAdapter.getDataSource().clear();
                scanGoodsAdapter.notifyItemRangeRemoved(0, previousSize);
                scanGoodsAdapter.add(scanGoodsPageInfo.getGoodsInfoList(), 0);
                scanGoodsAdapter.notifyItemRangeChanged(0, scanGoodsPageInfo.getGoodsInfoList().size());                //更新价格
                rcGoodsList.scrollToPosition(0);
            }
        }
        //更新价格
        refreshPayPrice(scanGoodsPageInfo.getOrderInfo());

        //弹出手改价格弹框
        if (viewScanGoodsPageInfo.getLastAddGoodsInfo() != null && viewScanGoodsPageInfo.getLastAddGoodsInfo().isManualPrice() && viewScanGoodsPageInfo.isNeedShowManualPrice()) {
            showManualPriceGoodsDialog(viewScanGoodsPageInfo.getLastAddGoodsInfo());
        }
    }


    /**
     * 弹出手改价格弹框
     *
     * @param viewGoodsInfo
     */
    void showManualPriceGoodsDialog(ViewGoodsInfo viewGoodsInfo) {
        if (viewGoodsInfo == null || !viewGoodsInfo.isManualPrice()) {
            return;
        }
        if (inputPriceDialog == null) {
            inputPriceDialog = new MposInputPriceDialog(this);
        }
        inputPriceDialog.setTitle(viewGoodsInfo.getGoodsName())
                .setOnActionDoneListener((action, result) -> {
                    if (action == MposInputPriceDialog.ACTION_CONFIRM) {
                        int price = Integer.parseInt(StringPriceFormat.transStringYuan2Fen(result));
                        manualPriceDone(viewGoodsInfo, price + "");
                    } else if (action == MposInputPriceDialog.ACTION_CLOSE) {
                        decreaseGoodsNumber(viewScanGoodsPageInfo.getGoodsInfoList(), viewGoodsInfo.getProductId(), true);
                    }
                }).show();
    }

    private List<ViewOptionalDiscountInfo> fixOptionalDiscountInfo(List<ViewOptionalDiscountInfo> optionalDiscountInfos) {
        for (int i = 0; i < optionalDiscountInfos.size(); i++) {
            if (i == 0) {
                optionalDiscountInfos.get(i).setSelect(true);
            } else {
                optionalDiscountInfos.get(i).setSelect(false);
            }
        }
        return optionalDiscountInfos;
    }


    void setEmptyGoodsState() {
        if (llScanGoods.getVisibility() == View.GONE) {
            llScanGoods.setVisibility(View.VISIBLE);
        }
        scanGoodsAdapter.getDataSource().clear();
        scanGoodsAdapter.notifyDataSetChanged();
        tvGoToPay.setEnabled(false);
        tvGoToPay.setText(getString(R.string.balance_order_with_good_num, 0));
//        tvTotalNum.setText(KeywordUtil.matcherSearch(getResources().getColor(R.color.face_pay_text_orange_color), getString(R.string.total_amount, (0 + "")), "[0-9]"));
        tvPayPrice.setText("￥" + 0.00);
    }

    void refreshPayPrice(ViewOrderInfo viewOrderInfo) {
        if (viewOrderInfo == null || scanGoodsAdapter == null || scanGoodsAdapter.getDataSource().size() == 0) {
            tvGoToPay.setEnabled(false);
            return;
        }
        tvGoToPay.setEnabled(true);
        tvGoToPay.setText(getString(R.string.balance_order_with_good_num, viewOrderInfo.getGoodsCount()));
//        tvTotalNum.setText(KeywordUtil.matcherSearch(getResources().getColor(R.color.face_pay_text_orange_color), getString(R.string.total_amount, (viewOrderInfo.getGoodsCount() + "")), "[0-9]"));
        tvPayPrice.setText("￥" + StringPriceFormat.transStringPriceToDecimalString(viewOrderInfo.getPayPrice()));

        if (!TextUtils.isEmpty(viewOrderInfo.getCouponPrice())) {
            tvTotalDisc.setVisibility(View.VISIBLE);
            tvTotalDisc.setText(getString(R.string.has_discount_amount, StringPriceFormat.transStringPriceToDecimalString(viewOrderInfo.getCouponPrice())));
        } else {
            tvTotalDisc.setVisibility(View.INVISIBLE);
        }
    }

    @Override
    protected void onQueryGoodsInfoFailed(String errorMsg) {
        super.onQueryGoodsInfoFailed(errorMsg);
        showErrMsg(errorMsg);
        hideWaitingDialog();
        refreshSubmitBtnStatus();
        if (manualInputDialog != null && manualInputDialog.isShowing()) {
            manualInputDialog.showCantRecognizeGoodsHint();
        }
        if (inputPriceDialog != null && inputPriceDialog.isShowing()) {
            inputPriceDialog.setErrMsg(errorMsg);
        }
    }

    private void showErrMsg(String errorMsg) {
        if (TextUtils.isEmpty(errorMsg)) {
            CenterToasty.error(this, "未知错误").show();
            return;
        }
        if (errorMsg.contains(ErrorPowerEnum.ERR_POWER_HOME.getCode())) {
            showErrorDialog(errorMsg, errorMsg, dialog -> {
                hideErrorDialog();
                clearDataSource();
                go2Home();
            });
            return;
        }
        if (errorMsg.contains(ErrorPowerEnum.ERR_POWER_NONE.getCode())) {
            showErrorDialog(errorMsg, errorMsg);
            return;
        }
        CenterToasty.error(this, errorMsg).show();
    }

    private void refreshSubmitBtnStatus() {
        if (viewScanGoodsPageInfo == null
                || viewScanGoodsPageInfo.getOrderInfo() == null
                || ListUtils.isEmpty(viewScanGoodsPageInfo.getGoodsInfoList())
                || scanGoodsAdapter == null
                || scanGoodsAdapter.getDataSource().size() == 0) {
            tvGoToPay.setEnabled(false);
            return;
        }
        tvGoToPay.setEnabled(true);
    }

    /**
     * @param code
     * @param isScan 是否是扫描动作
     */
    private void verifyCode(String code, boolean isScan) {
        if (code == null) {
            return;
        }
        //judge if is member no
        if (PhoneUtils.isPhoneNumber(code)) {
            verifyMemberInfo(code, isScan);
        } else {
            //goods barcode
            getGoodsInfoByBarcode(code);
        }
    }

    @OnClick(R2.id.layoutInputManual)
    public void onManualInputClicked(View view) {
        //show manual input dialog
        if (manualInputDialog != null) {
            manualInputDialog.show();
        }
    }


    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //有扫码事件输入 禁止同时点击 去付款按钮
        if (event.getKeyCode() != KeyEvent.KEYCODE_ENTER
                && KeyEvent.KEYCODE_VOLUME_DOWN != event.getKeyCode()
                && KeyEvent.KEYCODE_VOLUME_UP != event.getKeyCode()) {//音量键也不监听
            tvGoToPay.setEnabled(false);
        }
        StandardBroadcastInstance.sendUpdateOperateTimeBroadcast(this);
        scanGunKeyEventHelper.analysisKeyEvent(event);
        return true;
    }

    private void initGoodsRecyclerView() {
        scanGoodsAdapter = new LeGaoGoodsAdapter(new ArrayList<ViewGoodsInfo>(), this);
        rcGoodsList.setLayoutManager(new LinearLayoutManager(this));
        rcGoodsList.setAdapter(scanGoodsAdapter);
        DefaultItemAnimator defaultItemAnimator = new DefaultItemAnimator();
        defaultItemAnimator.setAddDuration(300);
        defaultItemAnimator.setRemoveDuration(300);
        rcGoodsList.setItemAnimator(defaultItemAnimator);
    }

    @OnClick(R2.id.tvUnLogin)
    public void onCancelPayClicked(View view) {//todo 这里加上退出登录的逻辑
        //judge if shop car has goods data
        if (scanGoodsAdapter != null && scanGoodsAdapter.getDataSource() != null && scanGoodsAdapter.getDataSource().size() > 0) {
            //show confirm dialog
            if (cancelOrderDialog != null) {
                cancelOrderDialog.show();
            }
        } else {
            //go home
            clearDataSource();
            go2Home();
        }
    }

    public void go2Home() {
        try {
            ARouter.getInstance().build(selfCashierTerminalConfig.getScoRuntimeConfig().getScoHomeActionViewActivityRouterPath()).navigation(this);
            finish();
            return;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        ARouter.getInstance().build(ARouterPathConstant.MPOS_HOME_ACTIVITY).navigation(this);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        cancelTrading();
        clearDataSource();
        dismissAllDialog();
        if (scanGunKeyEventHelper != null) {
            scanGunKeyEventHelper.onDestroy();
        }
    }

    /**
     * close all dialog
     */
    void dismissAllDialog() {
        if (cancelOrderDialog != null) {
            cancelOrderDialog.dismiss();
        }
        if (manualInputDialog != null) {
            manualInputDialog.dismiss();
        }
    }

    @Override
    protected void onScoLocalBroadcastReceive(Intent intent) {
        super.onScoLocalBroadcastReceive(intent);
        if (intent != null || !TextUtils.isEmpty(intent.getAction())) {
            if (intent.getAction().equals(BROADCAST_MANUAL_DECREASE)) {
                //减少商品
                ViewGoodsInfo viewGoodsInfo = (ViewGoodsInfo) intent.getSerializableExtra("decreaseGoodsInfo");
                if (scanGoodsAdapter != null && scanGoodsAdapter.getDataSource() != null) {
                    decreaseGoodsNumber(scanGoodsAdapter.getDataSource(), viewGoodsInfo.getProductId(), false);
                }
            }
            if (intent.getAction().equals(BROADCAST_MANUAL_INCREASE)) {
                //增加商品
                ViewGoodsInfo increaseGoodsInfo = (ViewGoodsInfo) intent.getSerializableExtra("increaseGoodsInfo");
                increaseGoodsNumber(increaseGoodsInfo);
            }
            if (intent.getAction().equals(BROADCAST_DELETE_GOODS)) {
                //删除商品
                int deleteGoodsPosition = intent.getIntExtra("deleteGoodsPosition", -1);
                if (scanGoodsAdapter != null && scanGoodsAdapter.getDataSource() != null && deleteGoodsPosition != -1) {
                    deleteGoodConfirmDialog.setViewGoodsInfo(scanGoodsAdapter.getDataSource().get(deleteGoodsPosition));
                    deleteGoodConfirmDialog.show();
                }
            }
            if (intent.getAction().equals(BROADCAST_CANCEL_ORDER)) {
                //取消交易
                cancelTrading();
                clearDataSource();
                go2Home();
            }
        }
    }


    @Override
    protected void onViewActionAbandon(ViewActions viewActions) {
        super.onViewActionAbandon(viewActions);
        tvGoToPay.setEnabled(true);
    }
}
