package com.miya.mpos.widget.dialog;

import android.content.Context;
import android.support.annotation.NonNull;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.TextView;

import com.miya.iot.sco.beans.viewbeans.ViewGoodsInfo;
import com.miya.iot.sco.core.broadcast.StandardBroadcastInstance;
import com.miya.iot.sco.core.utils.ContextUtils;
import com.miya.mpos.R;

/**
 * 确认删除商品对话框
 * <p>
 * Created by fengyu on 2018/2/11.
 */

public class DeleteGoodConfirmDialog extends BaseDialog {

    private TextView tvDeleteGoods;
    private TextView tvKeepGoods;


    private int selectPosition;
    private OnDeleteListener onDeleteListener;
    private ViewGoodsInfo viewGoodsInfo;

    public DeleteGoodConfirmDialog(@NonNull Context context) {
        super(context);
        initWindow();
        setContentView(R.layout.dialog_delete_goods_confirm);
        tvDeleteGoods = findViewById(R.id.tvDeleteGoods);
        tvKeepGoods = findViewById(R.id.tvKeepGoods);

        tvDeleteGoods.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (onDeleteListener != null) {
                    onDeleteListener.onDelete(viewGoodsInfo);
                } else {
                    StandardBroadcastInstance.sendGoodsDeleteBroadcast(ContextUtils.getContext(), selectPosition);
                }
                DeleteGoodConfirmDialog.this.dismiss();
            }
        });
        tvKeepGoods.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                DeleteGoodConfirmDialog.this.dismiss();
            }
        });
    }

    public DeleteGoodConfirmDialog setSelectPosition(int position) {
        selectPosition = position;
        return this;
    }

    private void initWindow() {
        Window win = this.getWindow();
        win.getDecorView().setPadding(0, 0, 0, 0);
        WindowManager.LayoutParams lp = win.getAttributes();
        lp.width = WindowManager.LayoutParams.MATCH_PARENT;
        lp.height = WindowManager.LayoutParams.WRAP_CONTENT;
        lp.gravity = Gravity.CENTER;
        win.setAttributes(lp);
        win.setBackgroundDrawableResource(android.R.color.transparent);
    }

    public void setOnDeleteListener(OnDeleteListener onDeleteListener) {
        this.onDeleteListener = onDeleteListener;
    }

    public void setViewGoodsInfo(ViewGoodsInfo viewGoodsInfo) {
        this.viewGoodsInfo = viewGoodsInfo;
    }

    public interface OnDeleteListener {
        void onDelete(ViewGoodsInfo viewGoodsInfo);
    }

}
