package com.miya.mpos.widget.dialog;

import android.content.Context;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.TextView;

import com.blankj.utilcode.util.ScreenUtils;
import com.miya.mpos.R;
import com.miya.mpos.widget.ClearTextView;
import com.miya.mpos.widget.CommonNumberKeyboard;

/**
 * Created by pupu on 2019-06-26
 * 佛祖开光，永无bug
 * God bless U
 */
public class ManualInputDialog extends BaseDialog {

    private ImageView ivCancel;
    private ClearTextView tvInputCode;
    private CommonNumberKeyboard numberKeyBoard;
    private TextView tvCantKnowGoods;
    private NumberInputFinishListener numberInputFinishListener;

    public ManualInputDialog(Context context) {
        super(context);
        initWindow();
        setContentView(R.layout.dialog_manual_input);
        tvCantKnowGoods = findViewById(R.id.tvCantKnowGoods);
        ivCancel = findViewById(R.id.iv_cancel);
        tvInputCode = findViewById(R.id.tvInputCode);
        numberKeyBoard = findViewById(R.id.numberKeyBoard);
        ivCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dismiss();
            }
        });

        tvInputCode.setOnClearListener(new ClearTextView.OnClearListener() {
            @Override
            public void onClearClick() {
                tvCantKnowGoods.setVisibility(View.INVISIBLE);
            }
        });


        numberKeyBoard.setKeyboardClickListener(new CommonNumberKeyboard.KeyboardClickListener() {
            @Override
            public void onNumClick(int num) {
                if (num == CommonNumberKeyboard.DELETE) {
                    if (TextUtils.isEmpty(tvInputCode.getText().toString())) {
                        return;
                    }
                    String currentCode = tvInputCode.getText().toString();
                    if (currentCode.length() <= 1) {
                        currentCode = "";
                        tvCantKnowGoods.setVisibility(View.INVISIBLE);
                    } else {
                        currentCode = currentCode.substring(0, currentCode.length() - 1);
                    }
                    tvInputCode.setText(currentCode);

                } else if (num == CommonNumberKeyboard.DONE) {
                    if (numberInputFinishListener != null) {
                        numberInputFinishListener.onInputFinishButtonClick(tvInputCode.getText().toString());
                    }
                } else {
                    String currentCode = tvInputCode.getText().toString();
                    currentCode = currentCode + num;
                    tvInputCode.setText(currentCode);
                }

            }
        });
    }

    private void initWindow() {
        Window win = this.getWindow();
        win.getDecorView().setPadding(0, 0, 0, 0);
        WindowManager.LayoutParams lp = win.getAttributes();
        lp.width = WindowManager.LayoutParams.MATCH_PARENT;
        lp.height = ScreenUtils.getScreenHeight() * 860/1280;
        lp.gravity = Gravity.BOTTOM;
        lp.windowAnimations = R.style.BottomInAndOutStyle;
        win.setAttributes(lp);
        win.setBackgroundDrawableResource(android.R.color.transparent);
    }

    public void setInputCode(String code) {
        tvInputCode.setText(code);
    }

    @Override
    public void dismiss() {
        super.dismiss();
        tvCantKnowGoods.setVisibility(View.INVISIBLE);
        tvInputCode.setText("");
    }

    public void showCantRecognizeGoodsHint() {
        tvCantKnowGoods.setVisibility(View.VISIBLE);
    }

    public void setNumberInputFinishListener(NumberInputFinishListener numberInputFinishListener) {
        this.numberInputFinishListener = numberInputFinishListener;
    }

    public interface NumberInputFinishListener {
        void onInputFinishButtonClick(String s);
    }

}
