package com.miya.mpos.widget.dialog;

import android.app.AlertDialog;
import android.content.Context;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.TextView;

import com.jakewharton.rxbinding.view.RxView;
import com.miya.iot.sco.core.broadcast.StandardBroadcastInstance;
import com.miya.iot.sco.core.utils.ContextUtils;
import com.miya.mpos.R;

import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

/**
 * 信息提示
 */
public class MessagePromptDialog extends BaseDialog {

    private TextView tvCancel, tvOk,tvHint;
    private View vDividingLine;

    public MessagePromptDialog(Context context,String hintMsg) {
        super(context);
        initWindow();
        setContentView(R.layout.dialog_message_prompt);
        setCancelable(false);
        setCanceledOnTouchOutside(false);
        tvOk = findViewById(R.id.tvOk);
        vDividingLine = findViewById(R.id.vDividingLine);
        tvCancel = findViewById(R.id.tvCancel);
        RxView.clicks(tvCancel)
                .throttleFirst(1500, TimeUnit.MILLISECONDS)
                .subscribe(aVoid -> {
                    dismiss();
                });
        tvHint = findViewById(R.id.tvHint);
        tvHint.setText(TextUtils.isEmpty(hintMsg)?"--":hintMsg);
    }

    private void initWindow() {
        Window win = this.getWindow();
        win.getDecorView().setPadding(0, 0, 0, 0);
        WindowManager.LayoutParams lp = win.getAttributes();
        lp.width = WindowManager.LayoutParams.MATCH_PARENT;
        lp.height = WindowManager.LayoutParams.WRAP_CONTENT;
        lp.gravity = Gravity.CENTER;
        win.setAttributes(lp);
        win.setBackgroundDrawableResource(android.R.color.transparent);
    }

    public MessagePromptDialog setOkButton(CharSequence text, OnClickListener listener) {
        tvOk.setText(TextUtils.isEmpty(text)?"确定":text);
        RxView.clicks(tvOk)
                .throttleFirst(1500, TimeUnit.MILLISECONDS)
                .subscribe(aVoid -> {
                    StandardBroadcastInstance.sendUpdateOperateTimeBroadcast(ContextUtils.getContext());
                    if(null != listener)listener.onClick(this,0);
                });
        refleshDividLine();
        return this;
    }

    public MessagePromptDialog setVisibility(boolean visibility) {
        tvCancel.setVisibility(visibility?View.VISIBLE:View.GONE);
        return this;
    }

    private void refleshDividLine(){
        if(tvCancel.getVisibility() != View.VISIBLE || tvOk.getVisibility() != View.VISIBLE){
            vDividingLine.setVisibility(View.GONE);
        }
    }
}
