package com.miya.mpos.widget.dialog;

import android.content.Context;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.blankj.utilcode.util.ScreenUtils;
import com.miya.iot.sco.beans.viewbeans.ViewCouponInfo;
import com.miya.iot.sco.core.utils.ListUtils;
import com.miya.iot.sco.core.utils.StringPriceFormat;
import com.miya.mpos.R;
import com.miya.mpos.widget.ClearTextView;
import com.miya.mpos.widget.CommonNumberKeyboard;
import com.widget.imagevideobanner.MainActivity;

import java.util.List;

public class MposDiscountDialog extends BaseDialog {

    private  LinearLayout llDiscDetail;
    private  TextView tvTotalDiscValue;
    private ImageView ivCancel;
    private Context mContext;

    public MposDiscountDialog(Context context) {
        super(context);
        mContext = context;
        initWindow();
        setContentView(R.layout.dialog_disc_list);
        ivCancel = findViewById(R.id.iv_cancel);
        llDiscDetail = findViewById(R.id.llDiscDetail);
        tvTotalDiscValue = findViewById(R.id.tvTotalDiscValue);
        ivCancel.setOnClickListener(v -> dismiss());
    }

    public void bindData(List<ViewCouponInfo> viewCouponInfos,String totalDisc) {
        if(!ListUtils.isEmpty(viewCouponInfos)){
            llDiscDetail.removeAllViews();
            for(ViewCouponInfo viewCouponInfo:viewCouponInfos){
                LinearLayout linearLayout = (LinearLayout) View.inflate(mContext, R.layout.dialog_disc_item, null);
                TextView tvDisc = linearLayout.findViewById(R.id.tvDisc);
                TextView tvDiscValue = linearLayout.findViewById(R.id.tvDiscValue);
                tvDisc.setText(viewCouponInfo.getCouponName());
                tvDiscValue.setText(mContext.getString(R.string.negative_price_with_currency, StringPriceFormat.transStringPriceToDecimalString(viewCouponInfo.getCouponPrice()) ));
                llDiscDetail.addView(linearLayout);
            }
        }
        tvTotalDiscValue.setText(mContext.getString(R.string.price_with_currency, StringPriceFormat.transStringPriceToDecimalString(totalDisc) ));
    }

    private void initWindow() {
        Window win = this.getWindow();
        win.getDecorView().setPadding(0, 0, 0, 0);
        WindowManager.LayoutParams lp = win.getAttributes();
        lp.width = WindowManager.LayoutParams.MATCH_PARENT;
        lp.height = ScreenUtils.getScreenHeight() * 800/1280;
        lp.gravity = Gravity.BOTTOM;
        lp.windowAnimations = R.style.BottomInAndOutStyle;
        win.setAttributes(lp);
        win.setBackgroundDrawableResource(android.R.color.transparent);
    }
}
