package com.miya.mpos.widget.dialog;

import android.content.Context;
import android.content.DialogInterface;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.blankj.utilcode.util.ScreenUtils;
import com.miya.iot.sco.core.broadcast.StandardBroadcastInstance;
import com.miya.iot.sco.core.utils.ButtonUtils;
import com.miya.iot.sco.core.utils.ContextUtils;
import com.miya.iot.sco.widget.CenterToasty;
import com.miya.mpos.R;
import com.miya.mpos.widget.ClearTextView;
import com.miya.mpos.widget.CommonNumberKeyboard;

import rx.functions.Action1;

/**
 * 员工登录
 */
public class StaffLoginDialog extends BaseDialog implements DialogInterface.OnShowListener {

    private EditText etStaffAccInput,etStaffPwdInput;
    private ImageView ivCancel;
    private TextView btnStaffLogin;

    public StaffLoginDialog(Context context) {
        super(context,R.style.inputResizeTheme);
        initWindow();
        setContentView(R.layout.dialog_staff_login);
        etStaffAccInput = findViewById(R.id.etStaffAccInput);
        etStaffPwdInput = findViewById(R.id.etStaffPwdInput);
        ivCancel = findViewById(R.id.ivCancel);
        btnStaffLogin = findViewById(R.id.btnStaffLogin);
        ivCancel.setOnClickListener(v -> dismiss());
        ButtonUtils.setNoMultiplyClickIn2sListener(btnStaffLogin, view -> {
            String account = etStaffAccInput.getText().toString();
            String passwd = etStaffPwdInput.getText().toString();
            if (!TextUtils.isEmpty(account) && !TextUtils.isEmpty(passwd)) {
                StandardBroadcastInstance.sendStaffLoginBroadcast(ContextUtils.getContext(),account,passwd);
            }else{
                CenterToasty.error(context, context.getString(R.string.incomplete_information)).show();
            }
        });
        setOnShowListener(this::onShow);
    }

    private void initWindow() {
        Window win = this.getWindow();
        win.getDecorView().setPadding(0, 0, 0, 0);
        WindowManager.LayoutParams lp = win.getAttributes();
        lp.width = WindowManager.LayoutParams.MATCH_PARENT;
        lp.height = ScreenUtils.getScreenHeight() * 920/1280;
        lp.gravity = Gravity.BOTTOM;
        lp.windowAnimations = R.style.BottomInAndOutStyle;
        win.setAttributes(lp);
        win.setBackgroundDrawableResource(android.R.color.transparent);
    }

    @Override
    public void onShow(DialogInterface dialog) {
        etStaffAccInput.setText("");
        etStaffPwdInput.setText("");
    }

}
