# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}
################common###############
-optimizationpasses 5 # 指定代码的压缩级别
-dontoptimize
-dontusemixedcaseclassnames
-dontskipnonpubliclibraryclasses
-dontpreverify
-verbose
-dontshrink
-keepattributes Exceptions,InnerClasses,Signature,Deprecated,SourceFile,LineNumberTable,Annotation,EnclosingMethod
 -keep public class * extends android.app.Activity
 -keep public class * extends android.app.Application
 -keep public class * extends android.app.Service
 -keep public class * extends android.content.BroadcastReceiver
 -keep public class * extends android.content.ContentProvider
 -keep public class * extends android.app.backup.BackupAgentHelper
 -keep public class * extends android.preference.Preference
 -keep public class com.android.vending.licensing.ILicensingService
 -keep public class * extends android.support.v4.app.Fragment
 -keep public class * extends android.app.Fragment

 -dontwarn android.support.**
 -keep class com.miya.iot.impl.**{*;}
 -keep class com.miyapay.huihua.face_pay.zoloz.**{ *; }
 -keep class com.miya.iot.sco.beans.**{ *; }
 -keep class com.miya.iot.sco.core_old.**{*;}
 -keep class com.fys.component.retrofit.**{ *; }
 -keep class com.miya.iot.sco.net.**{ *; }
 -keep class java.net.**{ *; }
 -keep class java.io.**{ *; }
 -keep class com.miya.iot.sco.contract.**{ *; }
 -keep class com.sdy.huihuaverify.core.**{ *; }
 -keep class com.miya.iot.sco.update.**{ *; }
 -keep class com.miya.iot.sco.printer.**{ *; }
 -keep class com.miya.iot.sco.datasource.**{ *; }
 -keepclassmembers class * extends android.app.Activity {
   private void *(android.net.Uri);
}

# Uncomment this to preserve the line number information for
# debugging stack traces.
#-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
#-renamesourcefileattribute SourceFile
-keepclassmembers class * extends org.greenrobot.greendao.AbstractDao {
public static java.lang.String TABLENAME;
}
-keep class **$Properties
-dontwarn com.alipay.api.internal.**
-dontwarn java.beans.**
# If you do not use SQLCipher:
-dontwarn org.greenrobot.greendao.database.**

  ## ----------Apache Commons-----------##
  -keep class org.apache.commons.** { *; }
  -dontwarn org.apache.commons.**
  ## ----------Apache Commons-----------##
-dontwarn org.apache.log4j.**
-dontwarn org.apache.commons.logging.**
-keep class org.** { *; }
 -keep class com.dfire.firechefs.api.retrofit.**{*;}
 -dontwarn com.google.gson.jpush.**
 -keep class com.google.gson.jpush.** { *;}
 -keep class android.support.** {
     *;
 }
 -keepclasseswithmembernames class * {
     native <methods>;
 }

 -keepclasseswithmembernames class * {
     public <init>(android.updateLog.Context, android.util.AttributeSet);
 }

 -keepclasseswithmembernames class * {
     public <init>(android.updateLog.Context, android.util.AttributeSet, int);
 }

 -keepclassmembers enum * {
     public static **[] values();
     public static ** valueOf(java.lang.String);
 }

 -keep class * implements android.os.Parcelable {
   public static final android.os.Parcelable$Creator *;
 }

 -keepclassmembers class **.R$* {
     public static <fields>;
 }

# 保护注解
-keepattributes *Annotation*
-keep class * extends java.lang.annotation.Annotation {*;}


#rxbus
-keep class com.hwangjr.rxbus.** { *; }

-keepclassmembers class ** {
    @com.hwangjr.rxbus.annotation.Subscribe <methods>;
}
-keepclassmembers class ** {
    @com.hwangjr.rxbus.annotation.Tag <methods>;
}

################Gson#######################
-keepattributes Signature
-keepattributes EnclosingMethod

# 不混淆内部类
-keepattributes InnerClasses
# Gson specific classes
-keep class sun.misc.Unsafe { *; }
# Application classes that will be serialized/deserialized over Gson
-keep class com.google.gson.** { *; }
-keep class com.google.gson.stream.** { *; }




# OkHttp
-keep class com.squareup.okhttp.** { *; }
-keep interface com.squareup.okhttp.** { *; }
-dontwarn com.squareup.okhttp.**
-keep class okhttp3.** { *; }
-dontwarn okhttp3.**
-keep class okhttp3.internal.**{*;}
# fastjson
-dontwarn com.alibaba.fastjson.**
## ----------mqtt-----------##
-keep class org.eclipse.paho.client.** { *; }
-keep class org.eclipse.paho.** { *; }
## ----------mqtt-----------##

## ----------Apache Commons-----------##
-keep class org.apache.commons.** { *; }
-dontwarn org.apache.commons.**
## ----------Apache Commons-----------##

## ----------dfireSDK-----------##
-keep class com.dfire.sdk.** { *; }
-dontwarn com.dfire.sdk.**
## ----------dfireSDK-----------##

# Okio
-keep class sun.misc.Unsafe{ *; }
-dontwarn java.nio.file.*
-dontwarn org.codehaus.mojo.animal_sniffer.IgnoreJRERequirement
-dontwarn okio.**


-dontwarn cn.jpush.**
-keep class cn.jpush.** { *;}

#videocache
-keep class com.danikula.videocache.** { *; }
-dontwarn com.danikula.videocache.**

# glide 的混淆代码
-keep public class * implements com.bumptech.glide.module.GlideModule
-keep public enum com.bumptech.glide.load.resource.bitmap.ImageHeaderParser$** {
  **[] $VALUES;
  public *;
}

-keepclassmembers enum * {
public static **[] values();
public static ** valueOf(java.lang.String);
}

-keep class org.apache.commons.lang3.**{*;}
 #如果引用了v4或者v7包
-dontwarn android.support.**


# retrofit2
# Platform calls Class.forName on types which do not exist on Android to determine platform.
-dontnote retrofit.Platform
# Platform used when running on RoboVM on iOS. Will not be used at runtime.
# Platform used when running on Java 8 VMs. Will not be used at runtime.
-dontwarn retrofit.Platform$Java8
-dontwarn org.w3c.dom.Node
# Retain declared checked exceptions for use by a Proxy instance.
-keepattributes Exceptions
-dontwarn retrofit2.**
-dontwarn retrofit.appengine.UrlFetchClient
-keep class retrofit2.** { *; }
-keepclasseswithmembers class * {
    @retrofit.http.* <methods>;
}






# RxJava RxAndroid
-dontwarn sun.misc.**
-keepclassmembers class rx.internal.util.unsafe.*ArrayQueue*Field* {
    long producerIndex;
    long consumerIndex;
}
-keepclassmembers class rx.internal.util.unsafe.BaseLinkedQueueProducerNodeRef {
    rx.internal.util.atomic.LinkedQueueNode producerNode;
}
-keepclassmembers class rx.internal.util.unsafe.BaseLinkedQueueConsumerNodeRef {
    rx.internal.util.atomic.LinkedQueueNode consumerNode;
}







#avloading
-keep class com.wang.avi.** { *; }
-keep class com.wang.avi.indicators.** { *; }
-keep class jp.wasabeef.** { *; }

#Bugly
-dontwarn com.tencent.bugly.**
-keep public class com.tencent.bugly.**{*;}
#butterknife
-keep class butterknife.** { *; }
-dontwarn butterknife.internal.**
-keep class **$$ViewBinder { *; }

-keepclasseswithmembernames class * {
    @butterknife.* <fields>;
}

-keepclasseswithmembernames class * {
    @butterknife.* <methods>;
}

 #cashupdate
-keep class com.dfire.mobile.cashupdate.bean.** {*;}
-dontwarn com.dfire.mobile.cashupdate.bean.**
# Configuration for Guava 18.0
#
# disagrees with instructions provided by Guava project: https://code.google.com/p/guava-libraries/wiki/UsingProGuardWithGuava

-keep class com.google.common.io.Resources {
    public static <methods>;
}
-keep class com.google.common.collect.Lists {
    public static ** reverse(**);
}
-keep class com.google.common.base.Charsets {
    public static <fields>;
}

-keep class com.google.common.base.Joiner {
    public static com.google.common.base.Joiner on(java.lang.String);
    public ** join(...);
}

-keep class com.google.common.collect.MapMakerInternalMap$ReferenceEntry
-keep class com.google.common.cache.LocalCache$ReferenceEntry
-dontwarn javax.annotation.**
-dontwarn javax.inject.**


-dontwarn cn.jiguang.**

-keep class cn.jiguang.** { *; }

#xml解析
-libraryjars <java.home>/lib/rt.jar
#-dontwarn android.support.**,de.greenrobot.**,org.simpleframework.xml.**
#
#
#-keep class org.simpleframework.**{ *; }
#-keepclassmembernames class org.simpleframework.**{ *; }
#-keepclasseswithmembers class org.simpleframework.**{ *; }
#
#
#
#
#
#-keep class android.support.**
#-keepclasseswithmembers class android.support.** { *;}
#
#-keep class org.simpleframeork.**
#-keepclasseswithmembers class org.simpleframeork.** { *;}
#
#-keep class javax.**
#-keepclasseswithmembers class javax.** { *;}
#
#
#
#
#
#
#-keep class org.simpleframework.**{ *; }
#-keep class org.simpleframework.xml.**{ *; }
#-keep class org.simpleframework.xml.core.**{ *; }
#-keep class org.simpleframework.xml.util.**{ *; }
#-keep class org.simpleframework.xml.stream.**{ *; }
#
#-keepclassmembers class * implements java.io.Serializable {
#    private static final java.io.ObjectStreamField[] serialPersistentFields;
#    private void writeObject(java.io.ObjectOutputStream);
#    private void readObject(java.io.ObjectInputStream);
#    java.lang.Object writeReplace();
#    java.lang.Object readResolve();
#}
-keepattributes ElementList, Root
-keep public class org.simpleframework.** { *; }
-dontwarn com.bea.xml.stream.**
-dontwarn org.simpleframework.xml.stream.**
-keep class org.simpleframework.xml.**{ *; }
-keepclassmembers,allowobfuscation class * {
    @org.simpleframework.xml.* <fields>;
    @org.simpleframework.xml.* <init>(...);
}
-dontwarn javax.xml.stream.events.**
-dontwarn javax.xml.**
-keepclassmembers class * {
    @org.simpleframework.xml.* *;
}
-keep interface org.simpleframework.xml.core.Label {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Label {
   public *;
}
-keep interface org.simpleframework.xml.core.Parameter {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Parameter {
   public *;
}
-keep interface org.simpleframework.xml.core.Extractor {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Extractor {
   public *;
}
-keep class com.alipay.api.** { *; }
-keep class java.beans.** { *; }
##-libraryjars ../core/libs/alipay-sdk-java.jar
##-libraryjars ../core/libs/SmileService1.9.1.jar
##-libraryjars ../core/libs/core-3.3.0.jar
-dontwarn  com.alipay.**

-dontwarn com.alipay.api.internal.**
-keep class com.alipay.** { *; }
-keep class com.google.zxing.** { *; }

-keep class test.org.tap.security.positiontable.** { *; }
-keep class org.tap.** { *; }
-keep class com.tap.operation.** { *; }
-dontwarn  org.tap.security.**
-keep class com.sdy.huihua.wechet_portrait.wechat.fragment.HuaRunOperatorFragment {*;}
-keep public class com.alibaba.android.arouter.routes.**{*;}
-keep class * implements com.alibaba.android.arouter.facade.template.ISyringe{*;}

# If you use the byType method to obtain Service, add the following rules to protect the interface:
-keep interface * implements com.alibaba.android.arouter.facade.template.IProvider

# If single-type injection is used, that is, no interface is defined to implement IProvider, the following rules need to be added to protect the implementation
-keep class * implements com.alibaba.android.arouter.facade.template.IProvider

# If @Autowired is used for injection in non-Activity classes, add the following rules to prevent injection failures
-keepnames class * {
    @com.alibaba.android.arouter.facade.annotation.Autowired <fields>;
}
-keep class com.baidu.tts.**{*;}
-keep class com.baidu.speechsynthesizer.**{*;}

# 称重硬件组件避免混淆
-keep class cn.wintec.wtandroidjar.**{*;}
-keep class com.miya.weighing.**{*;}
-keep class com.sunmi.electronicscaleservice.**{*;}
-keep class pupu.chuangjieweighing.**{*;}
-keep class android_serialport_api.**{*;}
-keep class com.miya.iot.sco.db.**{*;}
-keep class com.miya.iot.sco.db.entity.**{*;}

# greendao 混淆
-keep class freemarker.** { *; }
-dontwarn freemarker.**

-keep class org.greenrobot.greendao.**{*;}
-dontwarn org.greenrobot.greendao.**
-keep class com.miya.iot.sco.db.**{*;}
-keep class com.miya.iot.sco.db.entity.**{*;}

-keepclassmembers class * extends org.greenrobot.greendao.AbstractDao {
public static java.lang.String TABLENAME;
}
-keep class **$Properties

# 查看失败订单的商家操作页面不混淆
-keep class com.sdy.huihua.wechet_portrait.wechat.fragment.FailedTradeOpFragment {*;}
#串口通讯混淆配置
-keep class android_serialport_api.LampSerialPort {*;}
-keep class android_serialport_api.LampSerialPortFinder {*;}

# gif控件不混淆
-keep public class pl.droidsonroids.gif.GifIOException{<init>(int);}
-keep class pl.droidsonroids.gif.GifInfoHandle{<init>(long,int,int,int);}
-keep public class pl.droidsonroids.gif.GifIOException{<init>(int, java.lang.String);}

 -keep class com.widget.imagevideobanner.**{ *; }

-keep class wseemann.media.**{ *; }
-keep class wseemann.media.FFmpegMediaMetadataRetriever {
    *** mNativeContext;
}
#知而行券
-keep public class com.sweetmart.drm.**{*;}

#-dontusemixedcaseclassnames
#-dontskipnonpubliclibraryclasses
#-verbose
-ignorewarnings

######## copy from pay sdk on dev-3.0
-keep class **$Properties
-dontwarn java.beans.**
 ## ----------Apache Commons-----------##
-keep class org.apache.commons.** { *; }
-dontwarn org.apache.commons.**
  ## ----------Apache Commons-----------##
-dontwarn org.apache.log4j.**
-dontwarn org.apache.commons.logging.**
-keep class org.** { *; }
 -keepclasseswithmembernames class * {
     native <methods>;
 }

 -keepclasseswithmembernames class * {
     public <init>(android.updateLog.Context, android.util.AttributeSet);
 }

 -keepclasseswithmembernames class * {
     public <init>(android.updateLog.Context, android.util.AttributeSet, int);
 }

 -keepclassmembers enum * {
     public static **[] values();
     public static ** valueOf(java.lang.String);
 }

 -keep class * implements android.os.Parcelable {
   public static final android.os.Parcelable$Creator *;
 }

 -keepclassmembers class **.R$* {
     public static <fields>;
 }
# 保护注解
-keepattributes *Annotation*
-keep class * extends java.lang.annotation.Annotation {*;}
-keepclassmembers class ** {
    @com.hwangjr.rxbus.annotation.Subscribe <methods>;
}
-keepclassmembers class ** {
    @com.hwangjr.rxbus.annotation.Tag <methods>;
}

################Gson#######################
-keepattributes Signature
-keepattributes EnclosingMethod

# 不混淆内部类
-keepattributes InnerClasses
# Gson specific classes
-keep class sun.misc.Unsafe { *; }
# Application classes that will be serialized/deserialized over Gson
-keep class com.google.gson.** { *; }
-keep class com.google.gson.stream.** { *; }
# OkHttp
-keep class com.squareup.okhttp.** { *; }
-keep interface com.squareup.okhttp.** { *; }
-dontwarn com.squareup.okhttp.**
-keep class okhttp3.** { *; }
-dontwarn okhttp3.**
-keep class okhttp3.internal.**{*;}
-keep class okio.** { *; }

# fastjson
-dontwarn com.alibaba.fastjson.**
# Okio
-keep class sun.misc.Unsafe{ *; }
-dontwarn java.nio.file.*
-dontwarn org.codehaus.mojo.animal_sniffer.IgnoreJRERequirement
-dontwarn okio.**



-keepclassmembers enum * {
public static **[] values();
public static ** valueOf(java.lang.String);
}
-keep class org.apache.commons.lang3.**{*;}



# retrofit2
# Platform calls Class.forName on types which do not exist on Android to determine platform.
-dontnote retrofit.Platform
# Platform used when running on RoboVM on iOS. Will not be used at runtime.
# Platform used when running on Java 8 VMs. Will not be used at runtime.
-dontwarn retrofit.Platform$Java8
-dontwarn org.w3c.dom.Node
# Retain declared checked exceptions for use by a Proxy instance.
-keepattributes Exceptions
-dontwarn retrofit2.**
-dontwarn retrofit.appengine.UrlFetchClient
-keep class retrofit2.** { *; }
-keepclasseswithmembers class * {
    @retrofit.http.* <methods>;
}

#xml解析
-keepattributes ElementList, Root
-keep public class org.simpleframework.** { *; }
-dontwarn com.bea.xml.stream.**
-dontwarn org.simpleframework.xml.stream.**
-keep class org.simpleframework.xml.**{ *; }
-keepclassmembers,allowobfuscation class * {
    @org.simpleframework.xml.* <fields>;
    @org.simpleframework.xml.* <init>(...);
}
-dontwarn javax.xml.stream.events.**
-dontwarn javax.xml.**
-keepclassmembers class * {
    @org.simpleframework.xml.* *;
}
-keep interface org.simpleframework.xml.core.Label {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Label {
   public *;
}
-keep interface org.simpleframework.xml.core.Parameter {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Parameter {
   public *;
}
-keep interface org.simpleframework.xml.core.Extractor {
   public *;
}
-keep class * implements org.simpleframework.xml.core.Extractor {
   public *;
}

-keep class java.beans.** { *; }
-keep class test.org.tap.security.positiontable.** { *; }
-keep class org.tap.** { *; }
-keep class org.apache.log4j.** { *; }
-keep class com.tap.operation.** { *; }
-dontwarn  org.tap.security.**

-keep class rx.** { *; }
-keep class javax.** { *; }
-keep class com.miya.** { *; }
-keep class miyaapay.** { *; }
-keep class com.google.** { *; }
-keep class org.simpleframework.** { *; }
-keep class com.sdy.miya.moblie.component.pay.core.** { *; }
-keep class com.sdy.miya.moblie.component.pay.midhub.bean.** { *; }
-keep class com.sdy.miya.moblie.component.pay.midhub.sign.** { *; }
-keep class com.sdy.miya.moblie.component.pay.platform.bean.** { *; }
-keep class com.miya.** { *; }
-keep class com.sdy.miya.moblie.component.pay.platform.MiYaPlatformPayService{
 public *;
}
-keep class com.sdy.miya.moblie.component.pay.midhub.MiYaMidHubPayService{
 public *;
}
-keep class com.sdy.miya.moblie.component.pay.jar.MiYaJarPayService{
 public *;
}
-keep class MiYaPayMobileApiClient{
public *;
}
-keep class com.alibaba.fastjson.** { *; }
-keep class com.squareup.** { *; }
-dontwarn javax.**
-dontwarn rx.**
-dontwarn org.simpleframework.xml.**
-dontwarn com.google.gson.JsonParseException
# 米雅jar支付
-keep class com.sdy.miya.moblie.component.pay.jar.bean.** { *; }