package com.sdy.huihua.selfcashier_terminal;

import android.app.Application;
import android.content.Context;
import android.support.test.InstrumentationRegistry;
import android.support.test.runner.AndroidJUnit4;

import com.miya.iot.sco.core.actiondispatcher.PostActionCallback;
import com.miya.iot.sco.core.actiondispatcher.PostActionResult;
import com.miya.iot.sco.core.actiondispatcher.ViewActions;
import com.miya.iot.sco.core.component.ScoComponentProvider;
import com.miya.iot.sco.core.flowController.FlowControllerManager;
import com.miya.iot.sco.impl.component.ScoComponentProviderManager;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CountDownLatch;

import static com.miya.iot.sco.core.actiondispatcher.ViewActions.ACTION_TYPE_NORMAL;
import static com.miya.iot.sco.core.component.ScoCoreComponentName.SCO_COMPONENT_FLOWCONTROLMANAGER;
import static com.miya.iot.sco.impl.base.PostActionViewKeywords.STANDER_ACTION_VIEW_LOGIN;
import static com.miya.iot.sco.impl.base.PostActionViewKeywords.STANDER_ACTION_VIEW_SCAN_GOODS;
import static org.junit.Assert.assertEquals;

;

/**
 * Instrumented test, which will execute on an Android device.
 *
 * @see <a href="http://d.android.com/tools/testing">Testing documentation</a>
 */
@RunWith(AndroidJUnit4.class)
public class ExampleInstrumentedTest extends BaseTest {

    ScoComponentProvider scoComponentProvider;

    @Before
    public void createENV() {


        if (ScoComponentProviderManager.getCurrentComponentProvider() != null) {
            scoComponentProvider = ScoComponentProviderManager.getCurrentComponentProvider();
        } else {
            Context appContext = InstrumentationRegistry.getTargetContext();
            ScoComponentProviderManager.init((Application) appContext);
            scoComponentProvider = ScoComponentProviderManager.getCurrentComponentProvider();
        }


        ViewActions viewActions = new ViewActions();
        viewActions.setActionKey(STANDER_ACTION_VIEW_LOGIN);
        viewActions.setActionDesc("login");
        viewActions.setViewName("ScoLoginActionViewActivity");
        viewActions.setActionType(ViewActions.ACTION_TYPE_NORMAL);
        Map<String, Object> params = new HashMap<>();
        params.put("userName", "wfca03201");
        params.put("password", "123456");
        params.put("isScanLogin", false);
        params.put("isAutoLogin", true);
        viewActions.setParams(params);
        viewActions.setViewhasCode(this.hashCode());

        CountDownLatch countDownLatch = new CountDownLatch(1);
        FlowControllerManager flowControllerManager = (FlowControllerManager) scoComponentProvider.getComponentByName(SCO_COMPONENT_FLOWCONTROLMANAGER);
        flowControllerManager.asyncPostAction(viewActions, new PostActionCallback() {
            @Override
            public void onProgressFinish(PostActionResult postActionResult) {
                if (postActionResult.getIsSuccess() == 1) {
                    countDownLatch.countDown();
                } else {
                    throw new RuntimeException(postActionResult.getMsg());
                }
            }
        });
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }


    @Test
    public void scanGoodsTest() {
        Map<String, Object> params = new HashMap<>();
        params.put("goodsCode", "2300002400005");
        ViewActions viewActions = createViewActions(STANDER_ACTION_VIEW_SCAN_GOODS, params, "getGoodsInfoByBarcode", ACTION_TYPE_NORMAL);
        CountDownLatch countDownLatch = new CountDownLatch(1);
        FlowControllerManager flowControllerManager = (FlowControllerManager) scoComponentProvider.getComponentByName(SCO_COMPONENT_FLOWCONTROLMANAGER);
        flowControllerManager.asyncPostAction(viewActions, new PostActionCallback() {
            @Override
            public void onProgressFinish(PostActionResult postActionResult) {
                if (postActionResult.getIsSuccess() == 1) {
                    countDownLatch.countDown();
                } else {
                    throw new RuntimeException(postActionResult.getMsg());
                }
            }
        });
        try {
            countDownLatch.await();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }

    @Test
    public void useAppContext() {
        // Context of the app under test.
        Context appContext = InstrumentationRegistry.getTargetContext();

        assertEquals("com.sdy.huihua.selfcasher_land.test", appContext.getPackageName());
    }
}
